diff -r fb51f5b4aa4c trytond/res/group.py
--- a/trytond/res/group.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/res/group.py	Mon Sep 24 20:36:36 2012 +0200
@@ -4,22 +4,26 @@
 from itertools import chain
 from ..model import ModelView, ModelSQL, fields
 from ..transaction import Transaction
-from ..pool import Pool
+from ..pool import Pool, PoolMeta
+
+__all__ = [
+    'Group', 'Group2',
+    ]
 
 
 class MenuMany2Many(fields.Many2Many):
 
     def get(self, ids, model, name, values=None):
-        menu_obj = self.get_target()
+        Menu = self.get_target()
         res = super(MenuMany2Many, self).get(ids, model, name,
                 values=values)
         menu_ids = list(set(chain(*res.values())))
         test_ids = []
         for i in range(0, len(menu_ids), Transaction().cursor.IN_MAX):
             sub_ids = menu_ids[i:i + Transaction().cursor.IN_MAX]
-            test_ids.append(menu_obj.search([
-                ('id', 'in', sub_ids),
-                ]))
+            test_ids.append(map(int, Menu.search([
+                            ('id', 'in', sub_ids),
+                            ])))
         menu_ids = set(chain(*test_ids))
         for ids in res.itervalues():
             for id_ in ids[:]:
@@ -30,8 +34,7 @@
 
 class Group(ModelSQL, ModelView):
     "Group"
-    _name = "res.group"
-    _description = __doc__
+    __name__ = "res.group"
     name = fields.Char('Name', required=True, select=True, translate=True)
     model_access = fields.One2Many('ir.model.access', 'group',
        'Access Model')
@@ -43,67 +46,68 @@
     menu_access = MenuMany2Many('ir.ui.menu-res.group',
        'group', 'menu', 'Access Menu')
 
-    def __init__(self):
-        super(Group, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Group, cls).__setup__()
+        cls._sql_constraints += [
             ('name_uniq', 'unique (name)',
                 'The name of the group must be unique!')
         ]
 
-    def copy(self, ids, default=None):
-        int_id = isinstance(ids, (int, long))
-        if int_id:
-            ids = [ids]
-
+    @classmethod
+    def copy(cls, groups, default=None):
         if default is None:
             default = {}
         default = default.copy()
 
-        new_ids = []
-        for group in self.browse(ids):
+        new_groups = []
+        for group in groups:
             i = 1
             while True:
                 name = '%s (%d)' % (group.name, i)
-                if not self.search([('name', '=', name)], order=[]):
+                if not cls.search([('name', '=', name)], order=[]):
                     break
                 i += 1
             default['name'] = name
-            new_ids.append(super(Group, self).copy(group.id, default=default))
-        if int_id:
-            return new_ids[0]
-        return new_ids
+            new_groups.extend(super(Group, cls).copy([group], default=default))
+        return new_groups
 
-    def create(self, vals):
-        res = super(Group, self).create(vals)
+    @classmethod
+    def create(cls, vals):
+        res = super(Group, cls).create(vals)
         pool = Pool()
         # Restart the cache on the domain_get method
-        pool.get('ir.rule').domain_get.reset()
+        pool.get('ir.rule')._domain_get_cache.clear()
         # Restart the cache for get_groups
-        pool.get('res.user').get_groups.reset()
+        pool.get('res.user')._get_groups_cache.clear()
         # Restart the cache for get_preferences
-        pool.get('res.user').get_preferences.reset()
+        pool.get('res.user')._get_preferences_cache.clear()
         return res
 
-    def write(self, ids, vals):
-        res = super(Group, self).write(ids, vals)
+    @classmethod
+    def write(cls, groups, vals):
+        super(Group, cls).write(groups, vals)
         pool = Pool()
         # Restart the cache on the domain_get method
-        pool.get('ir.rule').domain_get.reset()
+        pool.get('ir.rule')._domain_get_cache.clear()
         # Restart the cache for get_groups
-        pool.get('res.user').get_groups.reset()
+        pool.get('res.user')._get_groups_cache.clear()
         # Restart the cache for get_preferences
-        pool.get('res.user').get_preferences.reset()
-        return res
+        pool.get('res.user')._get_preferences_cache.clear()
 
-    def delete(self, ids):
-        res = super(Group, self).delete(ids)
+    @classmethod
+    def delete(cls, groups):
+        super(Group, cls).delete(groups)
         pool = Pool()
         # Restart the cache on the domain_get method
-        pool.get('ir.rule').domain_get.reset()
+        pool.get('ir.rule')._domain_get_cache.clear()
         # Restart the cache for get_groups
-        pool.get('res.user').get_groups.reset()
+        pool.get('res.user')._get_groups_cache.clear()
         # Restart the cache for get_preferences
-        pool.get('res.user').get_preferences.reset()
-        return res
+        pool.get('res.user')._get_preferences_cache.clear()
 
-Group()
+
+class Group2:
+    __metaclass__ = PoolMeta
+    __name__ = "res.group"
+    users = fields.Many2Many('res.user-res.group', 'group', 'user', 'Users')
diff -r fb51f5b4aa4c trytond/res/ir.py
--- a/trytond/res/ir.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/res/ir.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,338 +1,320 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from ..model import ModelView, ModelSQL, Model, fields
+from ..model import ModelSQL, fields
 from ..backend import TableHandler
 from ..transaction import Transaction
-from ..pool import Pool
+from ..pool import Pool, PoolMeta
+
+__all__ = [
+    'UIMenuGroup', 'ActionGroup', 'ModelFieldGroup', 'ModelButtonGroup',
+    'RuleGroupGroup', 'RuleGroupUser', 'Lang', 'SequenceType',
+    'SequenceTypeGroup', 'Sequence', 'SequenceStrict',
+    'ModuleConfigWizardItem',
+    ]
+__metaclass__ = PoolMeta
 
 
 class UIMenuGroup(ModelSQL):
     "UI Menu - Group"
-    _name = 'ir.ui.menu-res.group'
-    _description = __doc__
+    __name__ = 'ir.ui.menu-res.group'
     menu = fields.Many2One('ir.ui.menu', 'Menu', ondelete='CASCADE',
             select=True, required=True)
     group = fields.Many2One('res.group', 'Group', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.0 table name change
-        TableHandler.table_rename(cursor, 'ir_ui_menu_group_rel', self._table)
+        TableHandler.table_rename(cursor, 'ir_ui_menu_group_rel', cls._table)
         TableHandler.sequence_rename(cursor, 'ir_ui_menu_group_rel_id_seq',
-                self._table + '_id_seq')
+                cls._table + '_id_seq')
         # Migration from 2.0 menu_id and gid renamed into menu group
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('menu_id', 'menu')
         table.column_rename('gid', 'group')
-        super(UIMenuGroup, self).init(module_name)
+        super(UIMenuGroup, cls).__register__(module_name)
 
-    def create(self, vals):
-        res = super(UIMenuGroup, self).create(vals)
+    @classmethod
+    def create(cls, vals):
+        res = super(UIMenuGroup, cls).create(vals)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
+        Pool().get('ir.rule')._domain_get_cache.clear()
         return res
 
-    def write(self, ids, vals):
-        res = super(UIMenuGroup, self).write(ids, vals)
+    @classmethod
+    def write(cls, records, vals):
+        super(UIMenuGroup, cls).write(records, vals)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
-        return res
+        Pool().get('ir.rule')._domain_get_cache.clear()
 
-    def delete(self, ids):
-        res = super(UIMenuGroup, self).delete(ids)
+    @classmethod
+    def delete(cls, records):
+        super(UIMenuGroup, cls).delete(records)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
-        return res
-
-UIMenuGroup()
+        Pool().get('ir.rule')._domain_get_cache.clear()
 
 
 class ActionGroup(ModelSQL):
     "Action - Group"
-    _name = 'ir.action-res.group'
-    _description = __doc__
+    __name__ = 'ir.action-res.group'
     action = fields.Many2One('ir.action', 'Action', ondelete='CASCADE',
             select=True, required=True)
     group = fields.Many2One('res.group', 'Group', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.0 table name change
-        TableHandler.table_rename(cursor, 'ir_action_group_rel', self._table)
+        TableHandler.table_rename(cursor, 'ir_action_group_rel', cls._table)
         TableHandler.sequence_rename(cursor, 'ir_action_group_rel_id_seq',
-                self._table + '_id_seq')
+                cls._table + '_id_seq')
         # Migration from 2.0 action_id and gid renamed into action and group
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('action_id', 'action')
         table.column_rename('gid', 'group')
-        super(ActionGroup, self).init(module_name)
+        super(ActionGroup, cls).__register__(module_name)
 
-    def create(self, vals):
-        action_obj = Pool().get('ir.action')
+    @classmethod
+    def create(cls, vals):
+        Action = Pool().get('ir.action')
         if vals.get('action'):
             vals = vals.copy()
-            vals['action'] = action_obj.get_action_id(vals['action'])
-        res = super(ActionGroup, self).create(vals)
+            vals['action'] = Action.get_action_id(vals['action'])
+        res = super(ActionGroup, cls).create(vals)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
+        Pool().get('ir.rule')._domain_get_cache.clear()
         return res
 
-    def write(self, ids, vals):
-        action_obj = Pool().get('ir.action')
+    @classmethod
+    def write(cls, records, vals):
+        Action = Pool().get('ir.action')
         if vals.get('action'):
             vals = vals.copy()
-            vals['action'] = action_obj.get_action_id(vals['action'])
-        res = super(ActionGroup, self).write(ids, vals)
+            vals['action'] = Action.get_action_id(vals['action'])
+        super(ActionGroup, cls).write(records, vals)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
-        return res
+        Pool().get('ir.rule')._domain_get_cache.clear()
 
-    def delete(self, ids):
-        res = super(ActionGroup, self).delete(ids)
+    @classmethod
+    def delete(cls, records):
+        super(ActionGroup, cls).delete(records)
         # Restart the cache on the domain_get method
-        Pool().get('ir.rule').domain_get.reset()
-        return res
-
-ActionGroup()
+        Pool().get('ir.rule')._domain_get_cache.clear()
 
 
 class ModelFieldGroup(ModelSQL):
     "Model Field Group Rel"
-    _name = 'ir.model.field-res.group'
-    _description = __doc__
+    __name__ = 'ir.model.field-res.group'
     field_id = fields.Many2One('ir.model.field', 'Model Field',
             ondelete='CASCADE', select=True, required=True)
     group_id = fields.Many2One('res.group', 'Group', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.0 table name change
         TableHandler.table_rename(cursor, 'ir_model_field_group_rel',
-            self._table)
+            cls._table)
         TableHandler.sequence_rename(cursor, 'ir_model_field_group_rel_id_seq',
-            self._table + '_id_seq')
-        super(ModelFieldGroup, self).init(module_name)
-
-ModelFieldGroup()
+            cls._table + '_id_seq')
+        super(ModelFieldGroup, cls).__register__(module_name)
 
 
 class ModelButtonGroup(ModelSQL):
     "Model Button - Group"
-    _name = 'ir.model.button-res.group'
-    _description = __doc__
+    __name__ = 'ir.model.button-res.group'
     button = fields.Many2One('ir.model.button', 'Button',
         ondelete='CASCADE', select=True, required=True)
     group = fields.Many2One('res.group', 'Group', ondelete='CASCADE',
         select=True, required=True)
     active = fields.Boolean('Active', select=True)
 
-    def __init__(self):
-        super(ModelButtonGroup, self).__init__()
-        for method in self._rpc:
-            self._rpc[method] = False
-
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def create(self, values):
+    @classmethod
+    def create(cls, values):
         pool = Pool()
-        result = super(ModelButtonGroup, self).create(values)
+        result = super(ModelButtonGroup, cls).create(values)
         # Restart the cache for get_groups
-        pool.get('ir.model.button').get_groups.reset()
+        pool.get('ir.model.button')._groups_cache.clear()
         return result
 
-    def write(self, ids, values):
+    @classmethod
+    def write(cls, records, values):
         pool = Pool()
-        result = super(ModelButtonGroup, self).write(ids, values)
+        super(ModelButtonGroup, cls).write(records, values)
         # Restart the cache for get_groups
-        pool.get('ir.model.button').get_groups.reset()
-        return result
+        pool.get('ir.model.button')._groups_cache.clear()
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, records):
         pool = Pool()
-        result = super(ModelButtonGroup, self).delete(ids)
+        super(ModelButtonGroup, cls).delete(records)
         # Restart the cache for get_groups
-        pool.get('ir.model.button').get_groups.reset()
-        return result
-
-ModelButtonGroup()
+        pool.get('ir.model.button')._groups_cache.clear()
 
 
 class RuleGroupGroup(ModelSQL):
     "Rule Group - Group"
-    _name = 'ir.rule.group-res.group'
-    _description = __doc__
+    __name__ = 'ir.rule.group-res.group'
     rule_group = fields.Many2One('ir.rule.group', 'Rule Group',
             ondelete='CASCADE', select=True, required=True)
     group = fields.Many2One('res.group', 'Group', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.0 table name change
-        TableHandler.table_rename(cursor, 'group_rule_group_rel', self._table)
+        TableHandler.table_rename(cursor, 'group_rule_group_rel', cls._table)
         TableHandler.sequence_rename(cursor, 'group_rule_group_rel_id_seq',
-                self._table + '_id_seq')
+                cls._table + '_id_seq')
         # Migration from 2.0 rule_group_id and group_id renamed into rule_group
         # and group
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('rule_group_id', 'rule_group')
         table.column_rename('group_id', 'group')
-        super(RuleGroupGroup, self).init(module_name)
-
-RuleGroupGroup()
+        super(RuleGroupGroup, cls).__register__(module_name)
 
 
 class RuleGroupUser(ModelSQL):
     "Rule Group - User"
-    _name = 'ir.rule.group-res.user'
-    _description = __doc__
+    __name__ = 'ir.rule.group-res.user'
     rule_group = fields.Many2One('ir.rule.group', 'Rule Group',
             ondelete='CASCADE', select=True, required=True)
     user = fields.Many2One('res.user', 'User', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.0 table name change
-        TableHandler.table_rename(cursor, 'user_rule_group_rel', self._table)
+        TableHandler.table_rename(cursor, 'user_rule_group_rel', cls._table)
         TableHandler.sequence_rename(cursor, 'user_rule_group_rel_id_seq',
-                self._table + '_id_seq')
+                cls._table + '_id_seq')
         # Migration from 2.0 rule_group_id and user_id renamed into rule_group
         # and user
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('rule_group_id', 'rule_group')
         table.column_rename('user_id', 'user')
-        super(RuleGroupUser, self).init(module_name)
+        super(RuleGroupUser, cls).__register__(module_name)
 
-RuleGroupUser()
 
+class Lang:
+    __name__ = 'ir.lang'
 
-class Lang(ModelSQL, ModelView):
-    _name = 'ir.lang'
+    @classmethod
+    def write(cls, langs, vals):
+        super(Lang, cls).write(langs, vals)
+        # Restart the cache for get_preferences
+        Pool().get('res.user')._get_preferences_cache.clear()
 
-    def write(self, ids, vals):
-        res = super(Lang, self).write(ids, vals)
-        # Restart the cache for get_preferences
-        Pool().get('res.user').get_preferences.reset()
-        return res
 
-Lang()
-
-
-class SequenceType(ModelSQL, ModelView):
-    _name = 'ir.sequence.type'
+class SequenceType:
+    __name__ = 'ir.sequence.type'
     groups = fields.Many2Many('ir.sequence.type-res.group', 'sequence_type',
             'group', 'User Groups',
             help='Groups allowed to edit the sequences of this type')
 
-SequenceType()
-
 
 class SequenceTypeGroup(ModelSQL):
     'Sequence Type - Group'
-    _name = 'ir.sequence.type-res.group'
-    _description = __doc__
+    __name__ = 'ir.sequence.type-res.group'
     sequence_type = fields.Many2One('ir.sequence.type', 'Sequence Type',
             ondelete='CASCADE', select=True, required=True)
     group = fields.Many2One('res.group', 'User Groups',
             ondelete='CASCADE', select=True, required=True)
 
-    def delete(self, ids):
-        rule_obj = Pool().get('ir.rule')
-        res = super(SequenceTypeGroup, self).delete(ids)
+    @classmethod
+    def delete(cls, records):
+        Rule = Pool().get('ir.rule')
+        super(SequenceTypeGroup, cls).delete(records)
         # Restart the cache on the domain_get method of ir.rule
-        rule_obj.domain_get.reset()
+        Rule._domain_get_cache.clear()
+
+    @classmethod
+    def create(cls, vals):
+        Rule = Pool().get('ir.rule')
+        res = super(SequenceTypeGroup, cls).create(vals)
+        # Restart the cache on the domain_get method of ir.rule
+        Rule._domain_get_cache.clear()
         return res
 
-    def create(self, vals):
-        rule_obj = Pool().get('ir.rule')
-        res = super(SequenceTypeGroup, self).create(vals)
-        # Restart the cache on the domain_get method of ir.rule
-        rule_obj.domain_get.reset()
-        return res
+    @classmethod
+    def write(cls, records, vals):
+        Rule = Pool().get('ir.rule')
+        super(SequenceTypeGroup, cls).write(records, vals)
+        # Restart the cache on the domain_get method
+        Rule._domain_get_cache.clear()
 
-    def write(self, ids, vals):
-        rule_obj = Pool().get('ir.rule')
-        res = super(SequenceTypeGroup, self).write(ids, vals)
-        # Restart the cache on the domain_get method
-        rule_obj.domain_get.reset()
-        return res
 
-SequenceTypeGroup()
-
-
-class Sequence(ModelSQL, ModelView):
-    _name = 'ir.sequence'
+class Sequence:
+    __name__ = 'ir.sequence'
     groups = fields.Function(fields.Many2Many('res.group', None, None,
         'User Groups'), 'get_groups', searcher='search_groups')
 
-    def get_groups(self, ids, name):
-        sequence_type_obj = Pool().get('ir.sequence.type')
-        sequences = self.browse(ids)
+    @classmethod
+    def get_groups(cls, sequences, name):
+        SequenceType = Pool().get('ir.sequence.type')
         code2seq = {}
         for sequence in sequences:
             code2seq.setdefault(sequence.code, []).append(sequence.id)
 
-        sequence_type_ids = sequence_type_obj.search([
+        sequence_types = SequenceType.search([
                 ('code', 'in', code2seq.keys()),
                 ])
-        sequence_types = sequence_type_obj.browse(sequence_type_ids)
 
-        res = {}
+        groups = {}
         for sequence_type in sequence_types:
             seq_ids = code2seq[sequence_type.code]
             for seq_id in seq_ids:
-                res.setdefault(seq_id, []).append(sequence_type.id)
+                groups.setdefault(seq_id, []).append(sequence_type.id)
 
-        return res
+        return groups
 
-    def search_groups(self, name, clause):
-        sequence_type_obj = Pool().get('ir.sequence.type')
-        ids = sequence_type_obj.search([clause], order=[])
-        seq_types = sequence_type_obj.browse(ids)
+    @staticmethod
+    def search_groups(name, clause):
+        SequenceType = Pool().get('ir.sequence.type')
+        seq_types = SequenceType.search([clause], order=[])
         codes = set(st.code for st in seq_types)
         return [('code', 'in', list(codes))]
 
-Sequence()
-
 
 class SequenceStrict(Sequence):
     # This empty class declaration is needed to inherit the groups
     # field
-    _name = 'ir.sequence.strict'
+    __name__ = 'ir.sequence.strict'
 
-SequenceStrict()
 
+class ModuleConfigWizardItem:
+    __name__ = 'ir.module.module.config_wizard.item'
 
-class ModuleConfigWizardItem(Model):
-    _name = 'ir.module.module.config_wizard.item'
-
-    def create(self, values):
+    @classmethod
+    def create(cls, values):
         pool = Pool()
-        user_obj = pool.get('res.user')
-        result = super(ModuleConfigWizardItem, self).create(values)
+        User = pool.get('res.user')
+        result = super(ModuleConfigWizardItem, cls).create(values)
         # Restart the cache for get_preferences
-        user_obj.get_preferences.reset()
+        User._get_preferences_cache.clear()
         return result
 
-    def write(self, ids, values):
+    @classmethod
+    def write(cls, items, values):
         pool = Pool()
-        user_obj = pool.get('res.user')
-        result = super(ModuleConfigWizardItem, self).write(ids, values)
+        User = pool.get('res.user')
+        super(ModuleConfigWizardItem, cls).write(items, values)
         # Restart the cache for get_preferences
-        user_obj.get_preferences.reset()
-        return result
+        User._get_preferences_cache.clear()
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, items):
         pool = Pool()
-        user_obj = pool.get('res.user')
-        result = super(ModuleConfigWizardItem, self).delete(ids)
+        User = pool.get('res.user')
+        super(ModuleConfigWizardItem, cls).delete(items)
         # Restart the cache for get_preferences
-        user_obj.get_preferences.reset()
-        return result
-
-ModuleConfigWizardItem()
+        User._get_preferences_cache.clear()
